<?php

namespace Drupal\fluent;

use Drupal\Core\Field\FieldDefinitionInterface;

/**
 *
 */
class FieldResolution {

  private FieldDefinitionInterface $fieldDefinition;

  private $field;

  private $value;

  private $parent;

  /**
   * @return mixed
   */
  public function getValue() {
    return $this->value;
  }

  /**
   * @param mixed $value
   */
  public function setValue($value): FieldResolution {
    $this->value = $value;
    return $this;
  }

  /**
   * @return mixed
   */
  public function getParent() {
    return $this->parent;
  }

  /**
   * @param mixed $parent
   */
  public function setParent($parent): FieldResolution {
    $this->parent = $parent;
    return $this;
  }

  /**
   * @return mixed
   */
  public function getFieldDefinition() {
    return $this->fieldDefinition;
  }

  /**
   * @param mixed $fieldDefinition
   */
  public function setFieldDefinition(FieldDefinitionInterface $fieldDefinition): FieldResolution {
    $this->fieldDefinition = $fieldDefinition;
    return $this;
  }

  /**
   * @return mixed
   */
  public function getField() {
    return $this->field;
  }

  /**
   * @param mixed $field
   */
  public function setField($field): FieldResolution {
    $this->field = $field;
    return $this;
  }

  /**
   *
   */
  public function isMultiValue(): bool {
    return (
      $this->fieldDefinition->getFieldStorageDefinition()->getCardinality() == -1
      ||
      $this->fieldDefinition->getFieldStorageDefinition()->getCardinality() > 1
      );
  }

}
