<?php

namespace Drupal\fluent\Plugin;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Field\FieldDefinitionInterface;
use Drupal\fluent\FieldControl;

/**
 * Defines an interface for Fluent field resolver plugins.
 */
interface FluentFieldResolverInterface extends PluginInspectionInterface {

  /**
   * @param \Drupal\Core\Field\FieldDefinitionInterface $fieldDefinition
   *
   * @return bool
   */
  public function can(FieldDefinitionInterface $fieldDefinition): bool;

  /**
   * @param $object
   * @param $fieldName
   * @param \Drupal\fluent\FieldControl $fieldControl
   *
   * @return mixed
   */
  public function handler($object, $fieldName, FieldControl $fieldControl);

}
