<?php

namespace Drupal\Tests\fluent\Functional;

use Drupal\Core\Datetime\DrupalDateTime;

/**
 * Test basic functionality of My Module.
 *
 * @group fluent
 */
class SingleValueTestCase extends FluentTestBase {

  public function testBaseNodeField() {
    $node = $this->getNode();
    $title = $node->getTitle();

    $this->assertEquals($title, using($node)->value('title'));
    $this->assertEquals('en', using($node)->value('langcode'));

    $this->assertIsInt(using($node)->value('nid'));
    $this->assertIsString(using($node)->value('id'));
    $this->assertInstanceOf(DrupalDateTime::class, using($node)->value('changed'));
    $this->assertInstanceOf(DrupalDateTime::class, using($node)->value('created'));
  }

  public function testCreatedField() {
    $image = $this->getMediaImage();
    $timestamp = $image->getCreatedTime();
    $ddateTime = fluent()->using($image)->value('created');

    $this->assertInstanceOf(DrupalDateTime::class, $ddateTime);
    $this->assertEquals($ddateTime->getTimestamp(), $timestamp);
  }

  public function testTaxonomyTermField() {
    // @todo
  }

}
